## emhash 1.0.0%2Bdfsg

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 17)
project(emhash_test)
if (CMAKE_BUILD_TYPE)
else()
    set(CMAKE_BUILD_TYPE RELEASE)
endif()

add_executable(emhash_test "main.cpp")

target_compile_features(emhash_test PRIVATE cxx_std_17)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffunction-sections -fdata-sections -march=native -Werror=conversion -Wno-sign-conversion -Wextra -Wpedantic -Wconversion")
#    target_compile_options(emhash_test PRIVATE -Werror -Wall -Wextra -Wold-style-cast -DTSL_DEBUG -UNDEBUG)
	target_compile_options(emhash_test PRIVATE -O3 -march=native -Wall -Wextra -DTSL_DEBUG -DNDEBUG)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    target_compile_options(emhash_test PRIVATE /bigobj /WX /W3 /DTSL_DEBUG /NDEBUG)
endif()

#include_directories(${PROJECT_SOURCE_DIR}/..)
include_directories(${PROJECT_SOURCE_DIR}/../thirdparty/)

# Boost::unit_test_framework
#find_package(Boost 1.74.0 REQUIRED COMPONENTS unit_test_framework)
#target_link_libraries(emhash_test PRIVATE Boost::unit_test_framework)

# tsl::robin_maphint(../ ${CMAKE_CURRENT_BINARY_DIR}/emhash)
#target_link_libraries(emhash_test PRIVATE emhash5::HashMap)

## emhash 1.0.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(emhash_bench)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

set(CMAKE_CXX_STANDARD 17)

message("------------ Options -------------")
message("  CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message("  CMAKE_SYSTEM_NAME: ${CMAKE_SYSTEM_NAME}")
message("  CMAKE_SYSTEM_PROCESSOR: ${CMAKE_SYSTEM_PROCESSOR} ")
message("  CMAKE_CXX_COMPILER_ID: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")

include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_SOURCE_DIR}/thirdparty)
include_directories(${PROJECT_SOURCE_DIR}/bench)

add_definitions(-DHAVE_BOOST=1 -DABSL_HAMP=1 -DEMH_PSL=16)# -DET=1)
find_package(Threads REQUIRED)

if(WIN32)
    set(CMAKE_CXX_FLAGS "/WX- /MP")
    set(CMAKE_CXX_FLAGS_DEBUG "/W3 /Zi /Od /WX- ${CMAKE_CXX_FLAGS}")
    set(CMAKE_CXX_FLAGS_RELEASE "/Ob1 /Ot /Oi /Oy /GL /arch:AVX ${CMAKE_CXX_FLAGS}")
    add_compile_options(/Ob2 /DNDEBUG /O2 /Ot /Oi /Oy /GL /arch:AVX)
elseif(1)
	set(CMAKE_CXX_FLAGS_DEBUG "-g fno-strict-aliasing ${CMAKE_CXX_FLAGS}")
    set(CMAKE_CXX_FLAGS "-flto=auto -march=native  ${CMAKE_CXX_FLAGS}")
endif()

add_executable(ebench ${PROJECT_SOURCE_DIR}/bench/ebench.cpp)
add_executable(sbench ${PROJECT_SOURCE_DIR}/bench/sbench.cpp)
add_executable(mbench ${PROJECT_SOURCE_DIR}/bench/martin_bench.cpp)
add_executable(bs ${PROJECT_SOURCE_DIR}/bench/bstring.cpp)
add_executable(bi ${PROJECT_SOURCE_DIR}/bench/buint64.cpp)
add_executable(fbench ${PROJECT_SOURCE_DIR}/bench/fbench.cpp)
add_executable(hbench ${PROJECT_SOURCE_DIR}/bench/hbench.cpp)
#add_executable(qbench ${PROJECT_SOURCE_DIR}/bench/qbench.cpp)
#add_executable(sibench ${PROJECT_SOURCE_DIR}/bench/simple_bench.cpp)

#target_link_libraries(ebench PRIVATE Threads::Threads)
#target_link_libraries(sbench PRIVATE Threads::Threads)
#target_link_libraries(mbench PRIVATE Threads::Threads)
#target_link_libraries(hbench PRIVATE Threads::Threads)
#target_link_libraries(fbench PRIVATE Threads::Threads)

=== debian/changelog ===
emhash (1.0.0+dfsg-0ubuntu3~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130190).
    - Changes to d/watch in last version changed the orig tarball.
      This version uses the orig tarball from LP.

 -- Will French <will.french@canonical.com>  Fri, 13 Feb 2026 15:35:40 -0600

emhash (1.0.0+dfsg-0ubuntu2~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130190).
    - d/watch: upgrade to version 5.
    - d/copyright: remove unused license.
    - d/source: remove unneeded lintian overrides.

 -- Will French <will.french@canonical.com>  Fri, 13 Feb 2026 14:46:19 -0600

emhash (1.0.0+dfsg-0ubuntu1~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130190).
    - d/control: mention that emhash-dev is a header only library
      in the binary package description.
    - d/copyright: remove bench folder from orig tarball.
    - d/copyright: prefer Expat over MIT based on lrc output.
    - d/copyright: remove unused thirdparty files from orig tarball.
    - d/copyright: misc fixes based on lrc and licensecheck reports.
    - d/emhash-dev.install: install thirdparty header that is conditionally
      included by root headers in project.
    - d/rules: disable configure and build steps to avoid building benchmark
      applications since these are not needed for packaging.
    - d/rules: enable tests.
    - d/watch: repack orig tarball with dfsg string in version string
      to signify removal of most vendored files from upstream repo.

 -- Will French <will.french@canonical.com>  Tue, 10 Feb 2026 15:59:02 -0600

emhash (1.0.0-0ubuntu2~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130190).
    - d/copyright: add files flagged by licensecheck -r.

 -- Will French <will.french@canonical.com>  Mon, 02 Feb 2026 14:44:26 -0600

emhash (1.0.0-0ubuntu1~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130190).

 -- Will French <will.french@canonical.com>  Mon, 12 Jan 2026 14:36:07 -0600

=== debian/control ===
Source: emhash
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake
Standards-Version: 4.7.2
Homepage: https://github.com/ktprime/emhash

Package: emhash-dev
Architecture: amd64
Section: libdevel
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Fast and memory-efficient C++ flat hash map/set
 Header files for C++ providing fast and memory-efficient
 open-addressing with flat hash table/map. This is a header-only
 library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	# Skip configure - header-only library, no build needed

override_dh_auto_build:
	# Skip build - header-only library

override_dh_auto_test:
	mkdir -p test/build && \
	cd test/build && \
	cmake $(CURDIR)/test && \
	$(MAKE) && \
	./emhash_test

=== debian/watch ===
Version: 5

Template: Github
Compression: xz
Dversionmangle: s/\+dfsg\d*$//
Owner: ktprime
Project: emhash
Repack: yes
Repacksuffix: +dfsg
Update-Script: uupdate
